Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class LetExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.Assignation
              net.sf.saxon.expr.LetExpression

All Implemented Interfaces:
  Binding, Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

Direct Known Subclasses:
  EagerLetExpression

public class LetExpression
extends Assignation

A LetExpression is modelled on the XQuery syntax let $x := expr return expr. This syntax is not available in the surface XPath language, but it is used internally in an optimized expression tree.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Assignation
`action, declaration, nameCode, sequence, slotNumber, variableName`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`LetExpression()`

Method Summary
`Expression` | `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` | `computeCardinality()` Determine the static cardinality of the expression
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`protected ValueRepresentation` | `eval(XPathContext context)` Evaluate the variable.
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression as a singleton
`ItemType` | `getItemType()` Determine the data type of the items returned by the expression, if possible
`SequenceIterator` | `iterate(XPathContext context)` Iterate over the sequence of values
`boolean` | `markTailFunctionCalls()` Mark tail function calls
`void` | `process(XPathContext context)` Process this expression as an instruction, writing results to the current outputter
`Expression` | `promote(PromotionOffer offer)` Promote this expression if possible

Methods inherited from class net.sf.saxon.expr.Assignation
`evaluateVariable, extendBindingList, getAction, getVariableFingerprint, getVariableName, getVariableNameCode, isGlobal, iterateSubExpressions, promoteWhereClause, setAction, setSequence, setSlotNumber, setVariableDeclaration, simplify`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LetExpression

    public LetExpression()

Method Detail

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Overrides:
    `checkPermittedContents` in class `ComputedExpression`
  Throws:
    `XPathException`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### eval

    protected ValueRepresentation eval(XPathContext context)
                                throws XPathException

  Evaluate the variable. (This is overridden in a subclass).

  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression as a singleton

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `ComputedExpression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process this expression as an instruction, writing results to the current outputter

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `ComputedExpression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType()

  Determine the data type of the items returned by the expression, if possible

  Returns:
    one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `ComputedExpression`

### markTailFunctionCalls

    public boolean markTailFunctionCalls()

  Mark tail function calls

  Overrides:
    `markTailFunctionCalls` in class `ComputedExpression`
  Returns:
    true if a tail recursive call was found and if this call accounts for the whole of the value.

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `Assignation`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD